package sun.awt.image;

import java.awt.image.ImageConsumer;

class ImageConsumerQueue
{
    ImageConsumerQueue next;
    ImageConsumer consumer;
    boolean interested;
    Object securityContext;
    boolean secure;
    
    static ImageConsumerQueue removeConsumer(ImageConsumerQueue imageConsumerQueue, ImageConsumer imageConsumer, boolean interested) {
        ImageConsumerQueue imageConsumerQueue2 = null;
        while (imageConsumerQueue != null) {
            if (imageConsumerQueue.consumer == imageConsumer) {
                if (imageConsumerQueue2 == null) {
                    imageConsumerQueue = imageConsumerQueue.next;
                }
                else {
                    imageConsumerQueue2.next = imageConsumerQueue.next;
                }
                imageConsumerQueue.interested = interested;
                break;
            }
            else {
                imageConsumerQueue2 = imageConsumerQueue;
                imageConsumerQueue = imageConsumerQueue.next;
            }
        }
        return imageConsumerQueue;
    }
    
    static boolean isConsumer(ImageConsumerQueue next, ImageConsumer imageConsumer) {
        while (next != null) {
            if (next.consumer == imageConsumer) {
                return true;
            }
            next = next.next;
        }
        return false;
    }
    
    ImageConsumerQueue(InputStreamImageSource inputStreamImageSource, ImageConsumer consumer) {
        this.consumer = consumer;
        this.interested = true;
        if ((consumer instanceof ImageRepresentation)) {
            if (((ImageRepresentation)consumer).image.source != inputStreamImageSource) {
                throw new SecurityException("ImageRep added to wrong image source");
            }
            this.secure = true;
        }
        else {
            SecurityManager securityManager = System.getSecurityManager();
            if (securityManager != null) {
                this.securityContext = securityManager.getSecurityContext();
            }
            else {
                this.securityContext = null;
            }
        }
    }
    
    @Override
    public String toString() {
        return "[" + this.consumer + ", " + (this.interested ? "" : "not ") + "interested" + ((this.securityContext != null) ? (", " + this.securityContext) : "") + "]";
    }
}
